/*----------------------------------------------------------------
 * animator.c - definice funkci animatoru
 *----------------------------------------------------------------
 */

#include <string.h>
#include <allegro.h>
#include <stdio.h>
#include "variable.h"
#include "animator.h"
#include "criterr.h"



ANIM_OBJECT_STRUCTURE *load_anim_object(char *name)
{
  char filename[40];
  char s[40];
  char gfxfile[40];
  FILE *file;
  int i, j = 10, k, l;
  ANIM_OBJECT_STRUCTURE *anim_object;

// vytvoreni ANIM_OBJECT_STRUCTURE
  anim_object = new ANIM_OBJECT_STRUCTURE;
//FIXME: chyba kdyz nejde vytvorit a ke konci vymazani

  // vynulovani posledniho casu animace
  anim_object->last_time = 0;

  strcpy(filename, TEXTS_DIR);
  strcat(filename, name);
  file = fopen( filename, "r");
  if( !file ) {
    critical_error ("Unable to open file %s", filename);
  }

// pocet obrazku s animacema
  fscanf(file, "%d\n", &anim_object->bitmap_count);
#ifdef DEBUG_VERSION
    fprintf(debugfile,"Nacitam %d obrazku\n", j);
#endif

// obrazky
  //anim_object -> image[anim_object->bitmap_count] = new BITMAP;
  anim_object -> image = new BITMAP *[anim_object->bitmap_count];

  for (i=0; i < anim_object->bitmap_count; i++) {
    fscanf(file, "%s\n", s);
    strcpy(gfxfile, GFX_DIR);
    strcat(gfxfile, s);
    if ((anim_object -> image[i] = load_bitmap(gfxfile, pal)) == NULL) {
        critical_error ("Unable to open file %s", gfxfile);
#ifdef DEBUG_VERSION
    fprintf(debugfile,"Nemohu nacist bitmapu %s\n", gfxfile);
#endif
    }

//SMAZAT    masked_blit (anim_object -> image[i], game_screen, 0, 0, 500, 400, 64, 64);
//SMAZAT    rest(500);

#ifdef DEBUG_VERSION
    fprintf(debugfile,"%s\n", gfxfile);
#endif
  }

// pocet framu

  fscanf(file, "%d\n", &j);

#ifdef DEBUG_VERSION
    fprintf(debugfile,"Nacitam %d framu\n", j);
#endif

    anim_object -> frame = new ONE_FRAME_STRUCTURE[j];

  for (i=0; i < j; i++) {
// obrazek sirka vyska pozice_v_obrazku_X pozice_v_obrazku_Y
// posunuti_X posunuti_Y
      fscanf(file, "%d ", &anim_object -> frame[i].image);
      fscanf(file, "%d %d ", &anim_object -> frame[i].width, &anim_object -> frame[i].height);
      fscanf(file, "%d %d ", &anim_object -> frame[i].image_position_X, &anim_object -> frame[i].image_position_Y);
      fscanf(file, "%d %d\n", &anim_object -> frame[i].move_X, &anim_object -> frame[i].move_Y);
  }


  // vynulovani countu framu
  for (i=0; i < TYPE_ANIMATION_COUNT; i++)  // vynulovani vsech poctu animaci
      anim_object->animation[i].count = 0;
// seznam framu
// pocet animaci celkem
  fscanf(file, "%d\n", &j);
#ifdef DEBUG_VERSION
    fprintf(debugfile,"Nacitam %d animaci\n", j);
#endif

  for (i=0; i < j; i++) {
    fscanf(file, "%d ", &k);
    fscanf(file, "%d\n", &anim_object -> animation[k].count);
    anim_object -> animation[k].frame = new FRAME_STRUCTURE[anim_object -> animation[k].count];
#ifdef DEBUG_VERSION
    fprintf(debugfile,"Nacitam animaci %d s %d animacemi\n", i, anim_object -> animation[k].count);
#endif

    for (l=0; l < anim_object -> animation[k].count; l++) {
        fscanf(file, "%d %d ", &anim_object -> animation[k].frame[l].index, &anim_object -> animation[k].frame[l].delay);
#ifdef DEBUG_VERSION
        fprintf(debugfile, "animation_frame_load: %d  delay: %d\n", anim_object -> animation[k].frame[l].index, anim_object -> animation[k].frame[l].delay);
#endif
    }
    fscanf(file, "%d\n", &anim_object -> animation[k].loop_start);
#ifdef DEBUG_VERSION
    fprintf(debugfile, "loop_start: %d\n", anim_object -> animation[k].loop_start);
#endif
  }

// cislo animace
// animace
  fclose(file);
// vynulovani frame a animation
  anim_object->actual_animation = 0;
  anim_object->actual_frame = 0;


  return anim_object;
}









int draw_anim_object(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y)
{
  int width, height;
  int frame, animation;
  int index;

    animation = anim_object->actual_animation;
    frame = anim_object->actual_frame;

  index = anim_object->animation[animation].frame[frame].index;
  width = anim_object->frame[index].width;
  height = anim_object->frame[index].height;

#ifdef TO_VIDEO
    acquire_bitmap(game_screen);
#endif


  masked_blit(
anim_object->image[anim_object->frame[index].image],
game_screen,
anim_object->frame[index].image_position_X,
anim_object->frame[index].image_position_Y,
anim_object->frame[index].move_X,
anim_object->frame[index].move_Y,
width,
height);


#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif



  return 0;
}







int fr_draw_anim_object(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame)
{
  int width, height;
  int index;

  index = anim_object->animation[animation].frame[frame].index;
  width = anim_object->frame[index].width;
  height = anim_object->frame[index].height;

#ifdef TO_VIDEO
    acquire_bitmap(game_screen);
#endif

/*
  masked_blit(
anim_object->image[anim_object->frame[index].image],
game_screen,
anim_object->frame[index].image_position_X,
anim_object->frame[index].image_position_Y,
anim_object->frame[index].move_X,
anim_object->frame[index].move_Y,
width,
height);
*/


  masked_blit(
anim_object->image[anim_object->frame[index].image],
game_screen,
anim_object->frame[index].image_position_X,
anim_object->frame[index].image_position_Y,
x + anim_object->frame[index].move_X,
y + anim_object->frame[index].move_Y,
width,
height);


#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif
  return 0;
}





int fr_draw_anim_object2(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame)
{
  int width, height;
  int index;

  index = anim_object->animation[animation].frame[frame].index;
  width = anim_object->frame[index].width;
  height = anim_object->frame[index].height;

#ifdef TO_VIDEO
    acquire_bitmap(game_screen2);
#endif

  masked_blit(
anim_object->image[anim_object->frame[index].image],
game_screen2,
anim_object->frame[index].image_position_X,
anim_object->frame[index].image_position_Y,
x + anim_object->frame[index].move_X,
y + anim_object->frame[index].move_Y,
width,
height);

#ifdef TO_VIDEO
    release_bitmap(game_screen2);
#endif
  return 0;
}




int draw_center_top(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame)
{
  int width, height;
  int index;
  index = anim_object->animation[animation].frame[frame].index;
  width = anim_object->frame[index].width;
  height = anim_object->frame[index].height;
#ifdef TO_VIDEO
    acquire_bitmap(game_screen);
#endif

	masked_blit(
anim_object->image[anim_object->frame[index].image],
game_screen,
anim_object->frame[index].image_position_X,
anim_object->frame[index].image_position_Y,
x - (anim_object->frame[index].width / 2) + anim_object->frame[index].move_X,
y + anim_object->frame[index].move_Y,
width,
height);
#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif
  return 0;
}



int draw_center_bottom(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame)
{
  int width, height;
  int index;
  index = anim_object->animation[animation].frame[frame].index;
  width = anim_object->frame[index].width;
  height = anim_object->frame[index].height;
#ifdef TO_VIDEO
    acquire_bitmap(game_screen);
#endif

	masked_blit(
anim_object->image[anim_object->frame[index].image],
game_screen,
anim_object->frame[index].image_position_X,
anim_object->frame[index].image_position_Y,
x - (anim_object->frame[index].width / 2) + anim_object->frame[index].move_X,
y - anim_object->frame[index].height + anim_object->frame[index].move_Y,
width,
height);
#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif
  return 0;
}




int get_animation(ANIM_OBJECT_STRUCTURE *anim_object)
{
    return anim_object->actual_animation;
}






int set_animation(ANIM_OBJECT_STRUCTURE *anim_object, int animation)
{
  //FIXME: pri nacitani nulovat vsechny animace, hlavne nultou a kontrolovat, zda se nulta opravdu nacetla
  if (anim_object->animation[animation].count == 0)
    anim_object->actual_animation = ANIMATION_DEFAULT;  // kdyz animace neexistuje, da defaultni
  else
    anim_object->actual_animation = animation;
  anim_object->actual_frame = 0;
  return 0;
}






int change_animation(ANIM_OBJECT_STRUCTURE *anim_object, int animation)
{
    int old;
    // na rozdil od set_animation nemeni frame
    // lze pouzit jen kdyz jsou stejne pocty frejmu, jinak nahodi nulty frame
        if (anim_object->actual_animation != animation) // zmeni animaci jen kdyz je jina
        {

            old = get_animation(anim_object);
            //FIXME: pri nacitani nulovat vsechny animace, hlavne nultou a kontrolovat, zda se nulta opravdu nacetla
            if (anim_object->animation[animation].count == 0)
            {
//                anim_object->actual_animation = ANIMATION_DEFAULT;  // kdyz animace neexistuje, da defaultni
//                anim_object->actual_frame = 0;  //FIXME: mozna by se dalo taky navazat na defaultni animaci
            }
            else
                anim_object->actual_animation = animation;

            if (anim_object->animation[old].count != anim_object->animation[animation].count)
                    anim_object->actual_frame = 0;  // vynuluje kdyz stara animace jiny pocet framu jak nova

        }





  return 0;
}





int stop_animation(ANIM_OBJECT_STRUCTURE *anim_object)
{
  //FIXME: zatim a mozna naporad konec animace = 0,0; ale neni to prave stopnuti animace!
  // tohle jinak asi finish_animation, ale zatim to nepotrebuji
  anim_object->actual_animation = 0;
  anim_object->actual_frame = 0;
  return 0;
}





int destroy_anim_object(ANIM_OBJECT_STRUCTURE *anim_object)
{
  int i;
  //FIXME - dopsat ? no mozna to uz je
  for (i=0; i < TYPE_ANIMATION_COUNT; i++)
    if (anim_object -> animation[i].count != 0)  delete [] anim_object -> animation[i].frame;
  delete [] anim_object -> frame;
  //FIXME - destroy_bitmap
  for (i=0; i<anim_object->bitmap_count; i++)
      destroy_bitmap(anim_object->image[i]);
  delete [] anim_object -> image;
  delete anim_object;
  return 0;
}





int animate_anim_object(ANIM_OBJECT_STRUCTURE *anim_object)
{
    // FIXME: muze byt float i lobg spolu?
    int time;
    long actual_time;
  //FIXME - dopsat a udelat zavisle na delay

    //FIXME: kdyz nulovy timer - hodi aktualni cas - da se vyresit jinak?
//    if (anim_object->last_time == 0)
//        anim_object->last_time = btime_;

    //actual_time = btime_;    // kdyby se zmenilo, beru radsi btime_ do promenne
    actual_time = cas;    // kdyby se zmenilo, beru radsi btime_ do promenne
    time = actual_time - anim_object->last_time;


    // smycka preskakovani animaci
    time -= anim_object->animation[anim_object->actual_animation].frame[anim_object->actual_frame].delay;


    while (time >= 0)
    {

        if ((anim_object->actual_frame + 1) >= anim_object->animation[anim_object->actual_animation].count)
        {
            //anim_object->actual_frame = 0;
            anim_object->actual_frame = anim_object->animation[anim_object->actual_animation].loop_start;
        }
        else
            anim_object->actual_frame++;
        time -= anim_object->animation[anim_object->actual_animation].frame[anim_object->actual_frame].delay;

    }
    // zkorigovani posledni animace vcetne zbytku


    anim_object ->last_time = actual_time - time - anim_object->animation[anim_object->actual_animation].frame[anim_object->actual_frame].delay;



/*
  if (anim_object->actual_frame == 0)
    anim_object->actual_frame = 1;
  else
    anim_object->actual_frame =0;
*/
  return 0;
}



int is_here(ANIM_OBJECT_STRUCTURE *anim_object, int draw_x, int draw_y)
{
    // draw_X a draw_Y nam dava souradnice, kde se tiskl
    // x a y ukazuje,kde cliknul kurzor
    int x, y;
    int width, height;
    int width_p;
    x = mouse_x;
    y = mouse_y;

    width = anim_object->frame[anim_object->actual_frame].width;
    height = anim_object->frame[anim_object->actual_frame].height;
    width_p = height / 2;

    //FIXME: poradne vycentrovat, jak se dohodne, kde je stred
    if ((draw_y - height < y) && (draw_x - width_p < x) && (draw_x + width_p > x))
    {
        return 1;
    }
    else
        return 0;
}

